class PathsMapper expands KeyPoint;

var PathsActor G;
var Actor HackedZone;
var Shoot_It Shooter;
var NavigationPoint N1, N2, N3, N4, N5, N6, N7, N8, N9, N10, N11, N12, N13, N14; //Asiggning points to connect

/*
,'GXech'
*/

/*
	This Keypoint is not compiled normally due to Navigation tunes requested. This is method for nasty low grav zones.
	Bot attempt to wander randomly blocking those teleporters and wasting time useless.
	KeyPoint Patcher will lock them as much as possible.
	We need also some links which doesn't exist.
	Several combat zones need Teleporters higher or else bot wuill telefrag any pawn - seriously that setup looks EVIL.
	Movers - WTF is here anyway, majority can be open with GRAB command - gimme a break.
	Mover in sniper zones what purpose do has that ? From now on it will open and we can get those dropped weapons
	by boosting up. Combat is balanced, they have Insta, we have Insta LOL.
	Not the last, PrecipitationGenerator sucks - it won't live that much.
*/

//=====
native(1718) final function bool AddToPackageMap( optional string PkgName );
//=====
native(1719) final function bool IsInPackageMap( optional string PkgName, optional bool bServerPackagesOnly ); //Second parameter doesn't exist in 227!
//=====
native(3540) final iterator function PawnActors( class<Pawn> PawnClass, out pawn P, optional float Distance,
optional vector VOrigin, optional bool bHasPRI, optional Pawn StartAt );
//=====
native(3541) final iterator function NavigationActors( class<NavigationPoint> NavClass, out NavigationPoint P,
optional float Distance, optional vector VOrigin, optional bool bVisible );
//=====
native(3542) final iterator function InventoryActors( class<Inventory> InvClass,
out Inventory Inv, optional bool bSubclasses, optional Actor StartFrom );
//=====
native(3552) final iterator function CollidingActors( class<actor> BaseClass, out actor Actor, float Radius,
optional vector Loc );
//=====
native(3553) final iterator function DynamicActors( class<actor> BaseClass, out actor Actor,
optional name MatchTag );
//=====
native(3560) static final function bool ReplaceFunction( class<Object> ReplaceClass,
class<Object> WithClass, name ReplaceFunction, name WithFunction, optional name InState );
//=====

event PreBeginPlay()
{
	log(Self.name@"Patching Level.",'GXech');
	G = Spawn( class'PathsActor' );
	ChangeNastyActors();
	AddMHObjectives();
	DoAlterBadPoints();
	SpawnShoters();
	InitialState='PathsMapping';
	log ("PreBeginPlay Completed...",'GXech');
}

event PostBeginPlay()
{
}

final function SpawnShoters()
{
}

function AddMHObjectives()
{
	local class<Actor> Wp;
	local Actor K1, K2, K3, K4, K5, K6, K7, K8, K9, K10, K11, K12, K13;
	local Actor tmp;


	Wp = class<Actor>(DynamicLoadObject("MonsterHunt.MonsterWayPoint",class'Class',True));
	if ( Wp != None )
	{
		WP.Default.bGameRelevant = True;
		K1 = Spawn(Wp,,,vect(3248,2456,-736)); //Invis Skaarj
		if ( K1 != None )
		{
			tmp = Spawn(class'TouchProtector',,,vect(3248,2456,-735));
			tmp.Tag = 'spw0ok';
			log (tmp.Name$" has Tag "$tmp.Tag,'GXech');
			tmp = None;
			log (K1.Name@"spawned at"@K1.Location,'GXech');
		}
		K2 = Spawn(Wp,,,vect(-488,-3984,-480)); //Weaponry and spam
		if ( K2 != None )
		{
			K2.SetPropertyText("Position","2");
			log (K2.Name@"spawned at"@K2.Location,'GXech');
		}
		K3 = Spawn(Wp,,,vect(-448,-5960,-480)); //Brutes
		if ( K3 != None )
		{
			K3.SetPropertyText("Position","3");
			tmp = Spawn(class'TouchProtector',,,vect(-448,-5960,-481));
			tmp.Tag = 'spw21ok';
			log (tmp.Name$" has Tag "$tmp.Tag,'GXech');
			tmp = None;
			log (K3.Name@"spawned at"@K3.Location,'GXech');
		}
		K4 = Spawn(Wp,,,vect(-3196,1644,-482)); //Kralls
		if ( K4 != None )
		{
			K4.SetPropertyText("Position","4");
			tmp = Spawn(class'TouchProtector',,,vect(-3196,1644,-481));
			tmp.Tag = 'MonsterEnd';
			log (tmp.Name$" has Tag "$tmp.Tag,'GXech');
			tmp = None;
			log (K4.Name@"spawned at"@K4.Location,'GXech');
		}
		K5 = Spawn(class'MonsterEvent',,,vect(-528,-5288,-168));
		if (K5 != None)
		{
			K5.Tag = 'spw21ok';
			MonsterEvent(K5).Message = "All Brutes have been eliminated, head back to Kralls...";
		}
		K6 = Spawn(class'MonsterEvent',,,vect(1888,1688,-296));
		if (K6 != None)
		{
			K6.Tag = 'spw0ok';
			MonsterEvent(K6).Message = "Completed! TENTACLES DOOR UNLOCKED!";
		}
		K7 = Spawn(class'MonsterEvent',,,vect(760,480,-296));
		if (K7 != None)
		{
			K7.Tag = 'gasdeurok';
			MonsterEvent(K7).Message = "Completed! GASBAGS DOOR UNLOCKED!";
		}
		K8 = Spawn(class'MonsterEvent',,,vect(-880,-1704,-144));
		if (K8 != None)
		{
			K8.Tag = 'spw2ok';
			MonsterEvent(K8).Message = "Completed! Proceed for Brutes!";
		}
	}
	else
	{
		log ("Did not find class MonsterWayPoint for objectives.",'GXech');
	}
}

final function DoAlterBadPoints()
{
	local NavigationPoint A;
	local InventorySpot In;
	local JumpSpot Ju;
	local LiftExit Li;
	local Teleporter Te;
	local PathNode Pa;
	local SpawnPoint Sp;
	local PlayerStart Pl;
	local int I;
	local string st;

	log ("Attempting to screw up X NavigationPoint actors...",'GXech');
	if ( G != None )
	{
		foreach NavigationActors(class'InventorySpot',In,30,vect(187,2984,-459))
		{
			if (string(In.Name) ~= "InventorySpot71")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(187,2966,-459))
		{
			if (string(In.Name) ~= "InventorySpot70")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(167,2984,-459))
		{
			if (string(In.Name) ~= "InventorySpot72")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(167,2966,-459))
		{
			if (string(In.Name) ~= "InventorySpot69")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-65,2952,-459))
		{
			if (string(In.Name) ~= "InventorySpot62")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-11,2952,-459))
		{
			if (string(In.Name) ~= "InventorySpot63")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-65,2976,-459))
		{
			if (string(In.Name) ~= "InventorySpot64")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-11,2976,-459))
		{
			if (string(In.Name) ~= "InventorySpot65")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(77,2928,-459))
		{
			if (string(In.Name) ~= "InventorySpot55")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-16,2688,-463))
		{
			if (string(In.Name) ~= "InventorySpot61")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				N1 = In;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PathNode',Pa,30,vect(21,1652,-461))
		{
			if (string(Pa.Name) ~= "PathNode1")
			{
				N2 = Pa;
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-192,2913,-459))
		{
			if (string(In.Name) ~= "InventorySpot57")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-192,2959,-459))
		{
			if (string(In.Name) ~= "InventorySpot58")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-227,2912,-459))
		{
			if (string(In.Name) ~= "InventorySpot59")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-227,2957,-459))
		{
			if (string(In.Name) ~= "InventorySpot60")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(162,2911,-459))
		{
			if (string(In.Name) ~= "InventorySpot68")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-39,2902,-459))
		{
			if (string(In.Name) ~= "InventorySpot56")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-144,2944,-459))
		{
			if (string(In.Name) ~= "InventorySpot54")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(-240,2704,-459))
		{
			if (string(In.Name) ~= "InventorySpot66")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'InventorySpot',In,30,vect(272,2688,-459))
		{
			if (string(In.Name) ~= "InventorySpot67")
			{
				G.CleanupNavSpecs(In);
				In.MarkedItem.MyMarker = None;
				In.MarkedItem = None;
				I++;
				log (In.Name@"is number"@I);
				break;
			}
		}
/*
		foreach NavigationActors(class'PathNode',Pa,30,vect(-1,2367,-461))
		{
			if (string(Pa.Name) ~= "PathNode3")
			{
				N2 = Pa;
				break;
			}
		}
*/
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-442,2639,-484))
		{
			if (string(Pl.Name) ~= "PlayerStart17")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-417,2812,-484))
		{
			if (string(Pl.Name) ~= "PlayerStart16")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-424,2990,-484))
		{
			if (string(Pl.Name) ~= "PlayerStart15")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-309,3125,-480))
		{
			if (string(Pl.Name) ~= "PlayerStart3")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(-174,3252,-480))
		{
			if (string(Pl.Name) ~= "PlayerStart8")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(6,3251,-480))
		{
			if (string(Pl.Name) ~= "PlayerStart1")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(174,3253,-480))
		{
			if (string(Pl.Name) ~= "PlayerStart7")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(315,3123,-480))
		{
			if (string(Pl.Name) ~= "PlayerStart2")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(443,2991,-479))
		{
			if (string(Pl.Name) ~= "PlayerStart13")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(445,2817,-479))
		{
			if (string(Pl.Name) ~= "PlayerStart12")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(447,2638,-479))
		{
			if (string(Pl.Name) ~= "PlayerStart11")
			{
//				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}
		foreach NavigationActors(class'PlayerStart',Pl,30,vect(364,2383,-479))
		{
			if (string(Pl.Name) ~= "PlayerStart14")
			{
				G.CleanupNavSpecs(Pl);
				Pl.bStatic = False;
				Pl.SetLocation(Pl.Location+Vect(0,0,30));
				Pl.bEnabled = False;
				Pl.bStatic = True;
				I++;
				log (Pl.Name@"is number"@I);
				break;
			}
		}

		foreach NavigationActors(class'LiftExit',Li,30,vect(6,2761,-464))
		{
			if (string(Li.Name) ~= "LiftExit1")
			{
				G.CleanupNavSpecs(Li);
				I++;
				log (Li.Name@"is number"@I);
				break;
			}
		}
//Useless dumbness - CreatureFactory slash ThingFactory has an array containing only 16 pieces, you genius...
		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(704,-6786,163))
		{
			if (string(sp.Name) ~= "Spawnpoint58")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(218,-7312,163))
		{
			if (string(sp.Name) ~= "Spawnpoint59")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(490,-7038,163))
		{
			if (string(sp.Name) ~= "Spawnpoint60")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(704,-5762,163))
		{
			if (string(sp.Name) ~= "Spawnpoint61")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(768,-6466,163))
		{
			if (string(sp.Name) ~= "Spawnpoint62")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(768,-6082,163))
		{
			if (string(sp.Name) ~= "Spawnpoint64")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(512,-5506,163))
		{
			if (string(sp.Name) ~= "Spawnpoint65")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(256,-5250,163))
		{
			if (string(sp.Name) ~= "Spawnpoint66")
			{
				Sp.Tag = '';
				break;
			}
		}
		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1848,3090,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint16")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1848,3346,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint17")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1152,2423,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint18")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1153,2678,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint19")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1782,232,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint20")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1786,-25,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint21")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1182,911,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint22")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-1183,1166,-472))
		{
			if (string(Sp.Name) ~= "Spawnpoint23")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(511,-2691,0))
		{
			if (string(Sp.Name) ~= "Spawnpoint40")
			{
				Sp.Tag = '';
				break;
			}
		}

		foreach NavigationActors(class'Spawnpoint',Sp,30,vect(-511,-2698,0))
		{
			if (string(Sp.Name) ~= "Spawnpoint41")
			{
				Sp.Tag = '';
				break;
			}
		}
	}

}

final function DoFakeNavigation()
{
	local RadiusMove RM0, RM1, RM2, RM3, RM4, RM5, RM6, RM7, RM8, RM9, RM10, RM11, RM12, RM13, RM14, RM15,
		RM16, RM17, RM18, RM19, RM20, RM21, RM22, RM23, RM24, RM25;
	local Dispatcher Ds0, Ds1, Ds2;

	RM0 = Spawn(class'RadiusMove',,,vect(-16,2824,-422));
	if ( RM0 != None )
	{
		RM0.RadiusRange=500;
		RM0.TimePush=3.000000;
		RM0.NamedActor="PathNode3";
		RM0.Tag='';
		RM0.bEnabled = True;
		RM0 = None;
	}
	RM1 = Spawn(class'RadiusMove',,,vect(16,2400,-359));
	if ( RM1 != None )
	{
		RM1.RadiusRange=600;
		RM1.TimePush=1.500000;
		RM1.NamedActor="PathNode1";
		RM1.Tag='';
		RM1.bEnabled = True;
		RM1 = None;
	}
}

final function ChangeNastyActors()
{
	local Actor A;

	foreach Level.AllActors(class 'Actor', A)
	{
		if (string(A.Name) ~= "Devilfish0")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "Devilfish1")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "Devilfish2")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "Devilfish3")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "ut_shieldbelt0")
		{
			ut_shieldbelt(A).ArmorAbsorption = ut_shieldbelt(A).class.default.ArmorAbsorption;
			ut_shieldbelt(A).Charge = ut_shieldbelt(A).class.default.Charge;
			ut_shieldbelt(A).RespawnTime = 12.000000;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool0")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool1")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool2")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool3")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool4")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "BiterFishSchool5")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "Squid0")
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "Behemoth0")
		{
				A.SetCollisionSize(A.class.default.CollisionRadius,A.class.default.CollisionHeight);
				A.DrawScale = 3.000000;
//				A.SetCollisionSize(A.CollisionRadius*A.DrawScale/A.Default.DrawScale, A.CollisionHeight*A.DrawScale/A.Default.DrawScale);
			continue;
		}
		if (string(A.Name) ~= "Fan0") //Ahah, spam my ass if you can...
		{
			A.SetCollision(False,False,False);
			A.bProjTarget = False;
			continue;
		}
		if (string(A.Name) ~= "Kicker1") //Pretty much dumb
		{
			A.LifeSpan = 0.2;
			continue;
		}
		if (string(A.Name) ~= "Mover2") //If this is crusher then crush the fucking All Pawns !!!
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).EncroachDamage = 100000;
			Mover(A).BumpType = BT_PawnBump;
			continue;
		}
		if (string(A.Name) ~= "ThingFactory2") //No spam
		{
			ThingFactory(A).MaxItems = 8;
			continue;
		}
		if (string(A.Name) ~= "Trigger2")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger3")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger4")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger5")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger6")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger7")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger8")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger9")
		{
			A.SetCollisionSize(90,40);
			continue;
		}
		if (string(A.Name) ~= "Trigger10")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger11")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger12")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger13")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Trigger14")
		{
			Trigger(A).RepeatTriggerTime = 8.700000;
			Trigger(A).ReTriggerDelay = 8.700000;
			continue;
		}
		if (string(A.Name) ~= "Trigger15")
		{
			Trigger(A).RepeatTriggerTime = 8.700000;
			Trigger(A).ReTriggerDelay = 8.700000;
			continue;
		}
		if (string(A.Name) ~= "Trigger17")
		{
			Trigger(A).RepeatTriggerTime = 8.700000;
			Trigger(A).ReTriggerDelay = 8.700000;
			continue;
		}
		if (string(A.Name) ~= "Trigger19")
		{
			A.SetCollisionSize(90,40);
			Trigger(A).RepeatTriggerTime = 3.500000;
			Trigger(A).ReTriggerDelay = 3.500000;
			continue;
		}
		if (string(A.Name) ~= "Mover4")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			continue;
		}
		if (string(A.Name) ~= "Mover12")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover22")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover21")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover20")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover11")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover10")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover9")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover8")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover5")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover19")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover18")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover17")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "Mover3")
		{
			Mover(A).InitialState = 'TriggerOpenTimed';
			Mover(A).StayOpenTime = 5.000000;
			continue;
		}
		if (string(A.Name) ~= "SteelBox0")
		{
			A.LifeSpan = 2.000000;
			continue;
		}
// Section removing TrojanHorse type stuff ruining server granted by awesome people "helping" with maps...
		if (string(A.Name) ~= "TeamCannon0")
		{
			A.LifeSpan = 1.000000;
			continue;
		}
		if (string(A.Name) ~= "TeamCannon1")
		{
			A.LifeSpan = 1.000000;
			continue;
		}
		if (string(A.Name) ~= "TeamCannon2")
		{
			A.LifeSpan = 1.000000;
			continue;
		}
		if (string(A.Name) ~= "TeamCannon3")
		{
			A.LifeSpan = 1.000000;
			continue;
		}
		if (string(A.Name) ~= "TeamCannon4")
		{
			A.LifeSpan = 1.000000;
			continue;
		}
		if (string(A.Name) ~= "TeamCannon5")
		{
			A.LifeSpan = 1.000000;
			continue;
		}
		if (string(A.Name) ~= "TeamCannon6")
		{
			A.LifeSpan = 1.000000;
			continue;
		}
// It's called K.O. in a second...
	}
}

final function SpawnPaths()
{
	if ( G != None )
	{
		if (N1 != None && N2 != None )
		{
			G.EzConnectNavigationPoints( N1,N2,,True );
				log ("Connected"@N1.Name@"and"@N2.Name,'GXEch');
		}
	}
	Spawn(class'SmartNode',,,vect(-504,-4312,-459));
	Spawn(class'SmartNode',,,vect(-482,-4829,-459));
	Spawn(class'SmartNode',,,vect(-528,-5520,-458));
	Spawn(class'SmartNode',,,vect(-440,-6120,-458));
	Spawn(class'SmartNode',,,vect(-384,-6680,-458));
}

function RestoreOriginal()
{
	local Actor A;
}

function DoReconnect()
{
	local NavigationPoint N;
	local ZoneInfo Z;
}

auto state PathsMapping
{
Begin:
	Sleep(0.2);
	log ("Navigation processing done, spawning new paths...",'GXech');
	SpawnPaths();
	Spawn(class'SomeActor');
	Sleep(0.0);
	DoFakeNavigation();
//	HackedZone.SetPropertyText("bWaterZone","False");
Sleep(0.5);
	DoReconnect();
	Spawn(class'TelPathsHacker');
	RestoreOriginal();
	GotoState('');
}

defaultproperties
{
	bMovable=False
	bStatic=False
	bGameRelevant=True
}
