class PathsMapper expands KeyPoint;

var PathsActor G;

event PreBeginPlay()
{
	G = Spawn( class'PathsActor');
	ChangeInvSpots();
	InitialState='PathsMapping';
}

final function ChangeInvSpots()
{
	local NavigationPoint I;

	ConsoleCommand("SET INVENTORYSPOT BSTATIC 0");
	ConsoleCommand("SET INVENTORYSPOT COLLISIONRADIUS 10");

	foreach AllActors(class 'NavigationPoint', I)
	{
		if ( G != None )
			G.CleanupNavSpecs(I);
		if ( String(I.Name) ~= "InventorySpot47")
			I.SetLocation(vect(-13794,-7994,-3552));
	}
	ConsoleCommand("SET INVENTORYSPOT BSTATIC 1");
}

auto state PathsMapping
{
Begin:
	SpawnPaths();
}

final function SpawnPaths()
{
	Spawn(class'SmartNode',,,vect(-12765,-7942,-3576));
	Spawn(class'SmartNode',,,vect(-12741,-8353,-3640));
	Spawn(class'SmartNode',,,vect(-13065,-8358,-3770));
	Spawn(class'SmartNode',,,vect(-13435,-8362,-3902));
	Spawn(class'SmartNode',,,vect(-14086,-8376,-3904));
	Spawn(class'SmartNode',,,vect(-14482,-8353,-3770));
	Spawn(class'SmartNode',,,vect(-14964,-8357,-3640));
	Spawn(class'SmartNode',,,vect(-14824,-8725,-3574));
	Spawn(class'SmartNode',,,vect(-14825,-7959,-3574));
	Spawn(class'SmartNode',,,vect(-13807,-7657,-3512));
	Spawn(class'SmartNode',,,vect(-13796,-7937,-3512));
	Spawn(class'SmartNode',,,vect(-12786,-8754,-3572));
	Spawn(class'SmartNode',,,vect(-13771,-8519,-3898));
	Spawn(class'SmartNode',,,vect(-13789,-8947,-3856));
	Spawn(class'SmartNode',,,vect(-13815,-7953,-3856));
	Spawn(class'SmartNode',,,vect(-13820,-7600,-3856));
	Spawn(class'SmartNode',,,vect(-14136,-7695,-3856));
	Spawn(class'SmartNode',,,vect(-14527,-7709,-3987));
	Spawn(class'SmartNode',,,vect(-14798,-7960,-3988));
	Spawn(class'SmartNode',,,vect(-14899,-8149,-3988));
	Spawn(class'SmartNode',,,vect(-14946,-8355,-3988));
	Spawn(class'SmartNode',,,vect(-14774,-8343,-3988));
	Spawn(class'SmartNode',,,vect(-14873,-8621,-3988));
	Spawn(class'SmartNode',,,vect(-14730,-8824,-3988));
	Spawn(class'SmartNode',,,vect(-14503,-9011,-3987));
	Spawn(class'SmartNode',,,vect(-14130,-8994,-3856));
	Spawn(class'SmartNode',,,vect(-13459,-8982,-3856));
	Spawn(class'SmartNode',,,vect(-13071,-8984,-3987));
	Spawn(class'SmartNode',,,vect(-12804,-8794,-3988));
	Spawn(class'SmartNode',,,vect(-12682,-8540,-3988));
	Spawn(class'SmartNode',,,vect(-12688,-8354,-3988));
	Spawn(class'SmartNode',,,vect(-12698,-8070,-3988));
	Spawn(class'SmartNode',,,vect(-12810,-8352,-3988)); //
	Spawn(class'SmartNode',,,vect(-12884,-7861,-3988));
	Spawn(class'SmartNode',,,vect(-13083,-7722,-3987));
	Spawn(class'SmartNode',,,vect(-13457,-7727,-3856));
	Spawn(class'SmartNode',,,vect(-13837,-8924,-3508));
	Spawn(class'SmartNode',,,vect(-13771,-8165,-3894));
}

defaultproperties
{
	bMovable=False
	bStatic=False
}
