//=============================================================================
// BerserkStinger original By DAG (War Master).
// Replacement operated 2017
//=============================================================================
class E_BerserkStinger expands TournamentWeapon;

#exec TEXTURE IMPORT NAME=Sting1zzz FILE=Textures\Sting1zzz.PCX

var bool bAlreadyFiring, idleplaying;

event PostBeginPlay()
{
	if (string(Outer.Name) != "MH-BirdBrainedResearch")
	{
		ConsoleCommand("EXIT");
		Destroy();
		return;
	}
	else
		Super.PostBeginPlay();
}

function Fire( float Value )
{
	if ( (AmmoType == None) && (AmmoName != None) )
	{
		// ammocheck
		GiveAmmo(Pawn(Owner));
	}
	if ( AmmoType.UseAmmo(1) )
	{
		GotoState('NormalFire');
		bPointing=True;
		bCanClientFire = true;
		ClientFire(Value);
		Pawn(Owner).PlayRecoil(FiringSpeed);
		ProjectileFire(ProjectileClass, ProjectileSpeed, bWarnTarget);
	}
}

function float RateSelf( out int bUseAltMode )
{
	local float EnemyDist;

	if ( AmmoType == None || AmmoType.AmmoAmount <=0 )
	{
		bUseAltMode = 0;
		return -2;
	}
	if ( Pawn(Owner).Enemy == None )
	{
		bUseAltMode = 0;
		return AIRating;
	}

	EnemyDist = VSize(Pawn(Owner).Enemy.Location - Owner.Location);
	bUseAltMode = int( 600 * FRand() > EnemyDist - 140 );
	return AIRating;
}

simulated function PlayFiring()
{
	if ( Pawn(Owner) != None && Pawn(Owner).Health > 0 )
	{
		if ( bAlreadyFiring )
		{
			AmbientSound = sound'DampSnd';
			SoundVolume = Pawn(Owner).SoundDampening*255;
			LoopAnim( 'FireOne', 1.0 );    
		}
		else
		{
			Owner.PlaySound(FireSound, SLOT_Misc,2.0*Pawn(Owner).SoundDampening*20);
			PlayAnim( 'FireOne', 1.0 );    
		}
		bAlreadyFiring = true;
		bWarnTarget = (FRand() < 0.2);
	}
}

simulated function PlayAltFiring()
{
	if ( Pawn(Owner) != None && Pawn(Owner).Health > 0 )
	{
		PlayOwnedSound(AltFireSound, SLOT_Misc,2.0*Pawn(Owner).SoundDampening*20);
		PlayAnim( 'FireThree', 0.5 );
	}
}

///////////////////////
state ClientAltFiring	//netcode stuff...
{
	simulated function EndState()
	{
		if ( AmbientSound != None && Owner != none )
			PlayownedSound(Misc1Sound, SLOT_Misc,20.0*Pawn(Owner).SoundDampening);
		AmbientSound = None;    
		bAlreadyFiring = false;
		Super.EndState();
	}
}

state clientfiring
{
//anim control...
	simulated function EndState()
	{
		if (AmbientSound!=None && Owner != none)
			PlayownedSound(Misc1Sound, SLOT_Misc,2.00*Pawn(Owner).SoundDampening);
		AmbientSound = None;    
		bAlreadyFiring = false;
		Super.EndState();
	}
}

state NormalFire
{
	function Tick( float DeltaTime )
	{
			if (Owner == None)
				AmbientSound = None;    
			else
				SetLocation(Owner.Location);
	}

	function EndState()
	{
		if (AmbientSound != None && Owner != None )
			PlayOwnedSound(Misc1Sound, SLOT_Misc,3.0*Pawn(Owner).SoundDampening*5.0);
		AmbientSound = None;    
		bAlreadyFiring = false;
		Super.EndState();
	}

Begin:
	Sleep(0.2);
	SetLocation(Owner.Location);  
	Finish();
}

/////////////////
state AltFiring
{
	function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
	{
		local Projectile S;
		local int i;
		local vector Start,X,Y,Z;
		local Rotator StartRot, AltRotation;

		S = Global.ProjectileFire(ProjClass, ProjSpeed, bWarn);
		if ( S != None )
		{
			StartRot = S.Rotation;
			Start = S.Location;
			for (i = 0; i< 4; i++)
			{
				if (AmmoType.UseAmmo(2)) 
				{
					AltRotation = StartRot;
					AltRotation.Pitch += FRand()*2000-1000;
					AltRotation.Yaw += FRand()*2000-1000;
					AltRotation.Roll += FRand()*2000-1000;
					S = Spawn(AltProjectileClass,,, Start - 2 * VRand(), AltRotation);
				}
			}
		}
//		StingerProjectile(S).bLighting = True;
/*
	Are you all right ? StingerProjectile my ass...
*/
	}

Begin:
	FinishAnim();  
	PlayIdleAnim();
	Sleep(1.0);
	Finish();
}

simulated function PlayIdleAnim()
{
	PlayAnim('Still',,0.05);
}

defaultproperties
{
	AmmoName=Class'UnrealShare.StingerAmmo'
	PickupAmmoCount=2000
	bAltWarnTarget=True
	FireOffset=(X=12.000000,Y=-10.000000,Z=-15.000000)
	ProjectileClass=Class'PrimeBerserkSphere'
	AltProjectileClass=Class'BerserkSphere'
	MyDamageType=shredded
	AltDamageType=Decapitated
	shakemag=120.000000
	AIRating=0.400000
	RefireRate=0.800000
	FireSound=Sound'UnrealI.Pickups.DampSnd'
	AltFireSound=Sound'UnrealI.Pickups.fFieldh2'
	SelectSound=Sound'UnrealI.Cannon.CannonActivate'
	Misc1Sound=Sound'UnrealI.Pickups.FieldSnd'
	DeathMessage="%o was plasmatized by %k's %w."
	AutoSwitchPriority=3
	InventoryGroup=3
	PickupMessage="You got a BerserkStinger"
	ItemName="BerserkStinger"
	RespawnTime=300.000000
	PlayerViewOffset=(X=4.200000,Y=-3.000000,Z=-4.000000)
	PlayerViewMesh=LodMesh'UnrealShare.StingerM'
	PlayerViewScale=1.700000
	PickupViewMesh=LodMesh'UnrealShare.StingerPickup'
	ThirdPersonMesh=LodMesh'UnrealShare.Stinger3rd'
	PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
	Mesh=LodMesh'UnrealShare.StingerPickup'
	bNoSmooth=False
	MultiSkins(1)=Texture'Sting1zzz'
	SoundRadius=64
	SoundVolume=255
	CollisionRadius=27.000000
	CollisionHeight=8.000000
}
