//=============================================================================
// WarChunk2.
//=============================================================================
class WarChunk2 expands UTChunk;

#exec MESH IMPORT MESH=chunk2M ANIVFILE=MODELS\chunk2_a.3D DATAFILE=MODELS\chunk2_d.3D X=0 Y=0 Z=0
#exec MESH ORIGIN MESH=chunk2M X=0 Y=0 Z=0 PITCH=0
#exec MESH SEQUENCE MESH=chunk2M SEQ=All    STARTFRAME=0   NUMFRAMES=1
#exec MESH SEQUENCE MESH=chunk2M SEQ=Still  STARTFRAME=0   NUMFRAMES=1
#exec MESHMAP SCALE MESHMAP=chunk2M X=0.03 Y=0.03 Z=0.06

	simulated function HitWall( vector HitNormal, actor Wall )
	{
		local float Rand;
		local UT_Sparks s;

		if ( (Mover(Wall) != None) && Mover(Wall).bDamageTriggered )
		{
			if ( Level.NetMode != NM_Client )
				Wall.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), MyDamageType);
			Destroy();
			return;
		}
		if ( Physics != PHYS_Falling ) 
		{
			SetPhysics(PHYS_Falling);
			if ( !Level.bDropDetail && (Level.Netmode != NM_DedicatedServer) && !Region.Zone.bWaterZone ) 
			{
				if ( FRand() < 0.5 )
				{
					HurtRadius(Damage,150.0, MyDamageType, MomentumTransfer, Location+HitNormal );
					s = Spawn(Class'UT_Sparks',,,Location+HitNormal*5,rotator(HitNormal));
					s.RemoteRole = ROLE_None;
				}
				else
					Spawn(class'WallCrack',,,Location, rotator(HitNormal));
			}
		}
		Velocity = 0.8*(( Velocity dot HitNormal ) * HitNormal * (-1.8 + FRand()*0.8) + Velocity);   // Reflect off Wall w/damping
		SetRotation(rotator(Velocity));
		speed = VSize(Velocity);
		if ( speed > 100 ) 
		{
			MakeNoise(0.3);
			Rand = FRand();
			if (Rand < 0.33)	PlaySound(sound 'Hit1', SLOT_Misc,0.6,,1000);	
			else if (Rand < 0.66) PlaySound(sound 'Hit3', SLOT_Misc,0.6,,1000);
			else PlaySound(sound 'Hit5', SLOT_Misc,0.6,,1000);
		}
	}

defaultproperties
{
     speed=3500.000000
     MaxSpeed=6000.000000
     Damage=35.000000
     LifeSpan=10.000000
     Mesh=LodMesh'Botpack.chunk2M'
     bNoSmooth=False
}
