//=============================================================================
// WarFlakSlug By DAG (War Master).
//=============================================================================

class WarFlakSlug expands Projectile;

var bool bCanHitOwner, bHitWater;
var float Count, SmokeRate;
var int NumExtraGrenades;

simulated function PostBeginPlay()
{
	local vector X,Y,Z;
	local rotator RandRot;

	Super.PostBeginPlay();
	if ( Level.NetMode != NM_DedicatedServer )
//		PlayAnim('WingIn'); //My ass !!!
		PlayAnim('Still');
	SetTimer(2.5+FRand()*0.5,false);	//Grenade begins unarmed
										//And clowns are mooing animations
	if ( Role == ROLE_Authority )
	{
		GetAxes(Instigator.ViewRotation,X,Y,Z);
		Velocity = X * (Instigator.Velocity Dot X)*0.4 + Vector(Rotation) * (Speed +
			FRand() * 100);
		Velocity.z += 210;
		MaxSpeed = 1000;
		RandSpin(50000);
		bCanHitOwner = False;
		if (Instigator.HeadRegion.Zone.bWaterZone)
		{
			bHitWater = True;
			Disable('Tick');
			Velocity=0.6*Velocity;
		}
	}
}

simulated function BeginPlay()
{
	if ( Level.bHighDetailMode && !Level.bDropDetail ) 
		SmokeRate = 0.03;
	else 
		SmokeRate = 0.15;
}

simulated function ZoneChange( Zoneinfo NewZone )
{
	local waterring w;

	if (!NewZone.bWaterZone || bHitWater) Return;

	bHitWater = True;
	w = Spawn(class'WaterRing',,,,rot(16384,0,0));
	if (w != None)
	{
		w.DrawScale = 0.2;
		w.RemoteRole = ROLE_None;
	}
	Velocity=0.6*Velocity;
}

simulated function Timer()
{
	Explosion(Location+Vect(0,0,1)*16);
}

simulated function Tick(float DeltaTime)
{
	local UT_superring b;

	if ( bHitWater || Level.bDropDetail ) 
	{
		Disable('Tick');
		Return;
	}
	Count += DeltaTime;
	if ( (Count>Frand()*SmokeRate+SmokeRate+NumExtraGrenades*0.03) && (Level.NetMode!=NM_DedicatedServer) ) 
	{
		b = Spawn(class'UT_superring');
		b.RemoteRole = ROLE_None;
		b.DrawScale = 0.3;	
		Count=0;
	}
}

simulated function Landed( vector HitNormal )
{
	HitWall( HitNormal, None );
}

simulated function ProcessTouch( actor Other, vector HitLocation )
{
	if ( (Other!=instigator) || bCanHitOwner )
		Explosion(HitLocation);
}

simulated function HitWall( vector HitNormal, actor Wall )
{
	bCanHitOwner = True;
	Velocity = 0.75*(( Velocity dot HitNormal ) * HitNormal * (-2.0) + Velocity);   // Reflect off Wall w/damping
	RandSpin(100000);
	speed = VSize(Velocity);
	if ( Level.NetMode != NM_DedicatedServer )
		PlaySound(ImpactSound, SLOT_Misc, 1.5 );
	if ( Velocity.Z > 400 )
		Velocity.Z = 0.5 * (400 + Velocity.Z);	
	else if ( speed < 20 ) 
	{
		bBounce = False;
		SetPhysics(PHYS_None);
	}
}

///////////////////////////////////////////////////////
function BlowUp(vector HitLocation)
{
	HurtRadius(damage*2.0, 300, MyDamageType, MomentumTransfer, HitLocation);
	Spawn( class'SuperShockExplo',,,HitLocation);
	Spawn( class 'WarChunk1',, '', HitLocation, rotrand());
	Spawn( class 'WarChunk2',, '', HitLocation, rotrand());
	Spawn( class 'WarChunk3',, '', HitLocation, rotrand());
	Spawn( class 'WarChunk2',, '', HitLocation, rotrand());
	MakeNoise(0.2);
}

simulated function Explosion(vector HitLocation)
{
	local ShockRifleWave s;

	BlowUp(HitLocation);
	if ( Level.NetMode != NM_DedicatedServer )
	{
		spawn(class'Botpack.BlastMark',,,,rot(16384,0,0));
		s = spawn(class'ShockRifleWave',,,HitLocation);
		s.RemoteRole = ROLE_None;
	}
	Destroy();
}

defaultproperties
{
	speed=1400.000000
	Damage=150.000000
	MomentumTransfer=75000
	MyDamageType=exploded
	ImpactSound=Sound'UnrealShare.Eightball.GrenadeFloor'
	ExplosionDecal=Class'Botpack.BlastMark'
	Physics=PHYS_Falling
	RemoteRole=ROLE_SimulatedProxy
	Mesh=LodMesh'Botpack.flakslugm'
	DrawScale=1.300000
	AmbientGlow=67
	bUnlit=True
	bBounce=True
	bFixedRotationDir=True
	DesiredRotation=(Pitch=12000,Yaw=5666,Roll=2334)
}
